summaryrefslogtreecommitdiff
path: root/Master/tlpkg
diff options
context:
space:
mode:
authorKarl Berry <karl@freefriends.org>2024-02-10 22:46:34 +0000
committerKarl Berry <karl@freefriends.org>2024-02-10 22:46:34 +0000
commit115a91adaf2fe8c2e6c7adb482740c759a04c10b (patch)
treea4b18ac3f94e82c4e255a61e680a9cc408a835e6 /Master/tlpkg
parent3397241eaee5ead7fd1f71e620bbe3e603241b56 (diff)
2024 pretest start
git-svn-id: svn://tug.org/texlive/trunk@69783 c570f23f-e606-0410-a88d-b1316a301751
Diffstat (limited to 'Master/tlpkg')
-rw-r--r--Master/tlpkg/TeXLive/TLConfig.pm4
-rwxr-xr-xMaster/tlpkg/bin/c2l9
-rwxr-xr-xMaster/tlpkg/bin/tl-update-bindir175
-rwxr-xr-xMaster/tlpkg/bin/tl-update-images5
-rwxr-xr-xMaster/tlpkg/bin/tl-update-messages2
-rwxr-xr-xMaster/tlpkg/bin/tl-update-tlnet4
-rw-r--r--Master/tlpkg/doc/releng.txt37
-rw-r--r--Master/tlpkg/tlpsrc/cweb.tlpsrc1
-rw-r--r--Master/tlpkg/tlpsrc/ptex.tlpsrc1
9 files changed, 124 insertions, 114 deletions
diff --git a/Master/tlpkg/TeXLive/TLConfig.pm b/Master/tlpkg/TeXLive/TLConfig.pm
index 4301c416821..0622adafab5 100644
--- a/Master/tlpkg/TeXLive/TLConfig.pm
+++ b/Master/tlpkg/TeXLive/TLConfig.pm
@@ -1,6 +1,6 @@
# $Id$
# TeXLive::TLConfig.pm - module exporting configuration values
-# Copyright 2007-2023 Norbert Preining
+# Copyright 2007-2024 Norbert Preining
# This file is licensed under the GNU General Public License version 2
# or any later version.
@@ -62,7 +62,7 @@ BEGIN {
# the year of our release, will be used in the location of the
# network packages, and in menu names, and other places.
-our $ReleaseYear = 2023;
+our $ReleaseYear = 2024;
# users can upgrade from this year to the current year; might be the
# same as the release year, or any number of releases earlier.
diff --git a/Master/tlpkg/bin/c2l b/Master/tlpkg/bin/c2l
index 263f35c01ef..5e1136d58f1 100755
--- a/Master/tlpkg/bin/c2l
+++ b/Master/tlpkg/bin/c2l
@@ -68,16 +68,17 @@ sub main {
$arg = "x86_64-linuxmusl";
} elsif ($arg eq "norbert" || $arg eq "nor") {
- for my $p (qw(i386-linux x86_64-linux x86_64-linuxmusl)) {
+ for my $p (qw(amd64-freebsd
+ i386-freebsd i386-linux i386-solaris
+ x86_64-linux x86_64-linuxmusl x86_64-solaris)) {
system ("$0 $p") && die "norbert/$p failed";
}
print "$0: norbert updates done.\n";
exit 0;
} elsif ($arg eq "cg" || $arg eq "moj" || $arg eq "mojca") {
- for my $p (qw(aarch64-linux amd64-freebsd armhf-linux
- i386-freebsd i386-solaris
- x86_64-darwinlegacy x86_64-solaris
+ for my $p (qw(aarch64-linux #armhf-linux
+ x86_64-darwinlegacy
)) {
system ("$0 $p") && die "cg/$p failed";
}
diff --git a/Master/tlpkg/bin/tl-update-bindir b/Master/tlpkg/bin/tl-update-bindir
index b79db37ba56..d03aadf9ed9 100755
--- a/Master/tlpkg/bin/tl-update-bindir
+++ b/Master/tlpkg/bin/tl-update-bindir
@@ -87,6 +87,45 @@ if test ! -d "$Master/bin"; then
exit 1
fi
+cgurl=https://build.contextgarden.net/dl/texlive/ # base url
+#
+# function to return url for the "latest" build on gh;
+# first argument is TL platform name,
+# second (optional) argument is github platform name, if different.
+#
+github_url ()
+{
+ if test -z "$1"; then
+ echo "$0:github_url: expected platform name, goodbye." >&2
+ exit 1
+ fi
+ tlplat=$1
+ ghplat=${2-$tlplat}
+ gh_url=https://api.github.com/repos/TeX-Live/texlive-source/releases/latest
+ remurl=`curl -s $gh_url \
+ | tee /tmp/gh-rel-$tlplat \
+ | grep browser_download_url \
+ | grep texlive-bin-$ghplat.tar.gz \
+ | cut -d : -f 2,3 \
+ | tr -d \"`
+ # get from tag?
+ #remurl=https://github.com/TeX-Live/texlive-source/releases/download/svn53987/texlive-bin-x86_64-linux.tar.gz
+ echo "github_url: for $tlplat, got $remurl" >&2
+ echo "$remurl"
+}
+
+# function to download a url passed as arg, or exit.
+#
+do_download ()
+{
+ if test -z "$1"; then
+ echo "$0:do_download: no url given, goodbye." >&2
+ exit 1
+ fi
+ $grab "$1" || exit $?
+}
+
+#
# loop through tl platform names
for tlplat in $tlplats; do
destdir=$Master/bin/$tlplat
@@ -97,139 +136,96 @@ for tlplat in $tlplats; do
fi
# karl update convenience
- default_bin_loc=
download_loc=$tmpdir/tl.$tlplat.tar.gz
+ default_bin_loc=$download_loc
grab="$download -O $download_loc"
+ #
if test x"$USER" = xkarl; then
case $tlplat in
aarch64-linux)
- default_bin_loc=$download_loc
- #https://faubox.rrze.uni-erlangen.de/open/MjdwNXE5NW5UcTU4RzVIWlRVUVVI/branch2018/texlive_bin_aarch64-linux.tar.xz
- #http://51.158.66.174:8080/texlive_bin_aarch64-linux.tar.xz
- #remurl=https://aekahwai.spdns.org/online/texlive_bin_aarch64-linux.tar.xz
- #remurl=https://taiyahfoboj.net/yeipaiyi/texlive_bin_aarch64-linux.tar.xz
- remurl=http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz
- $grab $remurl;;
- alpha-linux)
- default_bin_loc=/home/preining/alpha-linux.tar.gz;;
+ do_download ${cgurl}/${cgbranch}$tlplat.tar.xz;;
+
amd64-freebsd)
- default_bin_loc=$download_loc
- #https://www.preining.info/amd64-freebsd11.tar.gz
- #http://anthesphoria.net/FreeBSD/TeXLive-Devel/amd64-freebsd7.tar.xz
- remurl=http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz
- $grab $remurl;;
- amd64-kfreebsd)
- download_loc=$tmpdir/tl.$tlplat.tar.xz
- default_bin_loc=$download_loc
- grab="$download -O $download_loc"
- $grab ftp://ftp.cea.fr/incoming/y2k01/braslau/x86_64-unknown-kfreebsd9.0-gnu.tar.xz;;
+ do_download `github_url $tlplat`;;
+
amd64-netbsd)
download_loc=$tmpdir/tl.$tlplat.tar.xz
default_bin_loc=$download_loc
- grab="$download -O $download_loc"
- $grab http://www.babafou.eu.org/texlive-netbsd/x86_64-netbsd.tar.xz;;
- armel-linux)
- default_bin_loc=$download_loc
- $grab http://boris.lk.net/texlive-2013/armv7l-unknown-linux-gnueabi.tgz;;
+ do_download http://www.babafou.eu.org/texlive-netbsd/x86_64-netbsd.tar.xz;;
+
armhf-linux)
- default_bin_loc=$download_loc
remurl=http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz
- $grab $remurl;;
+ do_download $remurl;;
#simon $grab http://getthingsfixed.co.uk/texlive/builds/2022/texlive-armhf.tar.gz
- hppa-hpux)
- default_bin_loc=$download_loc
- $grab http://www.jtartlabs.com/test/hppa2.0-hp-hpux10.20.tar.gz;;
+
i386-cygwin)
- default_bin_loc=$download_loc
- $grab http://sanibeltranquility.com/cygwin/$tlplat.tgz;;
+ do_download http://sanibeltranquility.com/cygwin/$tlplat.tgz;;
+
i386-freebsd)
- download_loc=$tmpdir/tl.$tlplat.tar.xz
- default_bin_loc=$download_loc
- grab="$download -O $download_loc"
- #http://anthesphoria.net/FreeBSD/TeXLive-Devel/i386-freebsd7.tar.xz
- remurl=http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz
- $grab $remurl;;
- i386-kfreebsd)
- download_loc=$tmpdir/tl.$tlplat.tar.xz
- default_bin_loc=$download_loc
- grab="$download -O $download_loc"
- $grab ftp://ftp.cea.fr/incoming/y2k01/braslau/i386-unknown-kfreebsd10.0-gnu.tar.xz;;
+ do_download `github_url $tlplat`;;
+
i386-linux)
- default_bin_loc=$download_loc
- #remurl=http://dl.contextgarden.net/build/texlive/$tlplat.tar.xz
- remurl=`curl -s https://api.github.com/repos/TeX-Live/texlive-source/releases/latest | grep browser_download_url | grep texlive-bin-i386-linux.tar.gz | cut -d : -f 2,3 | tr -d \"`
- $grab $remurl;;
- i386-linuxmusl)
- default_bin_loc=$download_loc
- remurl=`curl -s https://api.github.com/repos/TeX-Live/texlive-source/releases/latest | grep browser_download_url | grep texlive-bin-i386-musl.tar.gz | cut -d : -f 2,3 | tr -d \"`
- $grab $remurl;;
+ do_download `github_url $tlplat`;;
+
i386-netbsd)
download_loc=$tmpdir/tl.$tlplat.tar.xz
default_bin_loc=$download_loc
grab="$download -O $download_loc"
$grab http://www.babafou.eu.org/texlive-netbsd/i386-netbsd.tar.xz;;
+
i386-openbsd)
default_bin_loc=$download_loc
$grab http://students.dec.bmth.ac.uk/ebarrett/files/tl-bin-20080810.tgz;;
+
i386-solaris)
- default_bin_loc=$download_loc
- $grab http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz;;
- mips-irix)
- download_loc=$tmpdir/tl.$tlplat.tar.xz
- default_bin_loc=$download_loc
- grab="$download -O $download_loc"
- $grab http://www.solid.ethz.ch/download/texlive/texlive-mips-irix.tar.xz;;
- mipsel-linux)
- echo "see mojca" >&2; exit 1;;
- powerpc-linux)
- default_bin_loc=/home/tschmitz/powerpc-linux.tar.xz;;
+ do_download `github_url $tlplat`;;
+
sparc-solaris)
- default_bin_loc=$download_loc
- $grab http://dl.contextgarden.net/build/texlive/$tlplat.tar.xz;;
+ do_download http://dl.contextgarden.net/build/texlive/$tlplat.tar.xz;;
+
universal-darwin)
- default_bin_loc=/home/koch/$tlplat.tar.xz
- ;;
+ default_bin_loc=/home/koch/$tlplat.tar.xz;;
+
windows)
;; # updated by Akira.
+
x86_64-cygwin)
- default_bin_loc=$download_loc
$grab http://sanibeltranquility.com/cygwin/$tlplat.tgz;;
+
x86_64-darwinlegacy)
- default_bin_loc=$download_loc
- $grab http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz;;
+ do_download ${cgurl}/${cgbranch}$tlplat.tar.xz;;
+
x86_64-linux)
- default_bin_loc=$download_loc
- #remurl=http://dl.contextgarden.net/build/texlive/$tlplat.tar.xz
# Visit https://github.com/TeX-Live/texlive-source/commits
# to check for commits.
# Then https://github.com/TeX-Live/texlive-source/releases
- # "Draft a new release";
- # use "svnNNNNN" in "Tag version" field,
+ # "Draft a new release".
+ # "Choose a tag -> "find or create a new tag" -> "svnNNNNN"
# "Target:trunk" should already be there,
# "rNNNNN and perhaps brief msg from commits in "title",
# and anything relevant for "description", or leave it blank;
# then "Publish release" (not as pre-release, can't be accessed).
- # After ~30min max, should have new release tarballs at:
+ #
+ # Can check status at:
+ # https://github.com/TeX-Live/texlive-source/actions
+ #
+ # After ~40min, should have new release tarballs at:
# https://github.com/TeX-Live/texlive-source/releases
- # (this is a different page than where you're put after creating
- # the release)
- # If failure, check:
- # https://www.travis-ci.org/TeX-Live/texlive-source
+ # (this is a different page than where you're put after creating
+ # the release)
+ # Some arches will be done sooner than others (arm and aarch are slow),
+ # but can't download anything until all are done.
#
# If try before ready, no harm, just get error message "missing url".
# (If you have/want a git checkout of texlive-source, see tlbuild doc.)
#
- remurl=`curl -s https://api.github.com/repos/TeX-Live/texlive-source/releases/latest | grep browser_download_url | grep texlive-bin-x86_64-linux.tar.gz | cut -d : -f 2,3 | tr -d \"`
- #remurl=https://github.com/TeX-Live/texlive-source/releases/download/svn53987/texlive-bin-x86_64-linux.tar.gz
- $grab $remurl;;
+ do_download `github_url $tlplat`;;
+
x86_64-linuxmusl)
- default_bin_loc=$download_loc
- remurl=`curl -s https://api.github.com/repos/TeX-Live/texlive-source/releases/latest | grep browser_download_url | grep texlive-bin-x86_64-linuxmusl.tar.gz | cut -d : -f 2,3 | tr -d \"`
- #remurl=http://dl.contextgarden.net/build/texlive/$tlplat.tar.xz
- $grab $remurl;;
+ do_download `github_url $tlplat`;;
+
x86_64-solaris)
- default_bin_loc=$download_loc
- $grab http://dl.contextgarden.net/build/texlive/${cgbranch}$tlplat.tar.xz;;
+ do_download `github_url $tlplat amd64-solaris`;;
esac
fi # end $USER=karl
@@ -267,6 +263,11 @@ for tlplat in $tlplats; do
# ditto, biber.
find "$srcdir" -name biber\* | xargs rm -f
+
+ # temp cleanup for first pretest24
+ find "$srcdir" -name htcontext\* | xargs rm -f
+ find "$srcdir" -name memoize-clean | xargs rm -f
+ find "$srcdir" -name memoize-extract | xargs rm -f
# may need to cd into a subdirectory, depending on how the tar was made.
while test `ls $srcdir | wc -l` -eq 1; do
diff --git a/Master/tlpkg/bin/tl-update-images b/Master/tlpkg/bin/tl-update-images
index 5d6a8f1077f..c30068d5147 100755
--- a/Master/tlpkg/bin/tl-update-images
+++ b/Master/tlpkg/bin/tl-update-images
@@ -2,7 +2,7 @@
# $Id$
# Create the .iso image(s) for TeX Live.
#
-# Copyright 2007-2023 Karl Berry.
+# Copyright 2007-2024 Karl Berry.
# Copyright 2003, 2004, 2005 Sebastian Rahtz.
#
# This file is licensed under the GNU General Public License version 2
@@ -18,12 +18,13 @@ unset CDPATH # avoid output from cd
umask 022
NAME=texlive
-V=2023
+V=2024
D=`date +%Y%m%d`
target=/home/ftp/texlive/Images/test
XZ_OPT=-6e; export XZ_OPT # compression level, -9 for slowest-but-most,
# which is not worth the (excessive) time.
+ # The -e is also for better compression.
mydir=`cd \`dirname $0\` && /bin/pwd`
cd $mydir || exit 1 # the Master/tlpkg/bin directory
diff --git a/Master/tlpkg/bin/tl-update-messages b/Master/tlpkg/bin/tl-update-messages
index dc58f25acf1..5db86276049 100755
--- a/Master/tlpkg/bin/tl-update-messages
+++ b/Master/tlpkg/bin/tl-update-messages
@@ -23,7 +23,7 @@ cat install-tl >>$tmpfile
xgettext -o tlpkg/translations/messages.pot \
--copyright-holder="TeX Live Team" \
--msgid-bugs-address=tex-live@tug.org \
- --package-version=2023 \
+ --package-version=2024 \
--package-name="TeX Live" \
-k__ -k\$__ -k%__ -k__x -k__n:1,2 -k__nx:1,2 -k__xn:1,2 -kN__ -k \
texmf-dist/scripts/texlive/tlmgrgui.pl \
diff --git a/Master/tlpkg/bin/tl-update-tlnet b/Master/tlpkg/bin/tl-update-tlnet
index 2910416ec75..6aa7d9f6830 100755
--- a/Master/tlpkg/bin/tl-update-tlnet
+++ b/Master/tlpkg/bin/tl-update-tlnet
@@ -1,5 +1,5 @@
#!/bin/sh -e
-# Copyright 2008-2023 Norbert Preining
+# Copyright 2008-2024 Norbert Preining
# This file is licensed under the GNU General Public License version 2
# or any later version.
#
@@ -13,7 +13,7 @@ renice 20 $$ >/dev/null 2>&1
unset CDPATH
unset LS_COLORS
-yyyy=2023
+yyyy=2024
adjust_repo=1
check_consistency=true
diff --git a/Master/tlpkg/doc/releng.txt b/Master/tlpkg/doc/releng.txt
index 220ae1996c0..9b186922d79 100644
--- a/Master/tlpkg/doc/releng.txt
+++ b/Master/tlpkg/doc/releng.txt
@@ -69,28 +69,31 @@ affecting production dirs, see:
it's important, because this summary of changes is what users want to know.
- if new kpathsea file types (kpsewhich --help-formats), update kpathsea.texi.
- see also doc item below for more necessary updates after pretest starts.
-
+
6. During the pretest, we want to keep updating tlnet. But we cannot do
that from the trunk, since the trunk will have the new binaries and
-other changes. Therefore, we set up a branch for release YYYY where we
-will continue to commit normal package updates and update tlnet, while
-the trunk is updating tlpretest for YYYY+1.
+other changes. Therefore, we set up a branch named YYYY.final (YYYY =
+the last TL release) where we will continue to commit normal package
+updates and update tlnet, while the trunk is updating tlpretest for
+YYYY+1 (= the current calendar year).
The branch must be created right before the first pretest-specific
commit (which is the next item, in Part II). Ensure *.pm are updated in
Build/source first.
cd /home/texlive/branch
- rm -rf * .[^.]* # empty completely; be sure .svn et al. are gone
- rev=65870 # for 2023 (svn info in trunk)
+ rm -rf * .[^.]*; ls -a # empty completely; be sure .svn et al. are gone
+ # get revision for end of tl24/start of tl24; make sure it's sensible:
+ rev=`svn info /home/texlive/trunk | \grep '^Revision:'`; echo $rev
tlyear=`date +%Y -d "last year"`; echo $tlyear # previous release
umask 022 # keep TL files non-group-writable
+ # make the .final
branch=branch$tlyear.final
svn copy -r $rev \
-m"$branch branch based on r$rev" \
svn://tug.org/texlive/trunk svn://tug.org/texlive/branches/$branch
# make working checkout:
- time svn co svn://tug.org/texlive/branches/$branch . >&/tmp/out # ~45min
+ time svn co svn://tug.org/texlive/branches/$branch . >&/tmp/cout # ~60min
Do not create it earlier and merge from trunk, because then all the
packages which got updated in the meantime, and have been updated in
@@ -109,7 +112,8 @@ the repo while we're working.
1. Set up tlpretest:
Update /home/ftp/texlive/tlpretest/README.md.
-Empty tlpretest except for that README and 00_TIME.txt (used for mirmon).
+Empty tlpretest except for that README.md and 00_TIME.txt (used for mirmon),
+and rename TEXLIVE_YYYY_pretest for the new year.
2. Prepare for pretest in cron.tl, with these temporary settings (will
reset below):
@@ -134,31 +138,32 @@ Master/texmf-dist/web2c/texmf.cnf # from Build/.../kpathsea
5. Ensure version numbers in sources are updated; see list above.
Then install new binaries with tl-update-bindir. Ask tlbuild.
Add new executables to appropriate .tlpsrc files (likewise removals).
- (svn status bin/x86_64-linux | grep '^[^M]')
-Add any man pages for the new executables (from Build/source/inst/...)
+ Check with, e.g.: svn status bin/x86_64-linux | grep '^[^M]'
+ (We'll do man pages later with tl-update-man.)
Add new scripts to linked_scripts if not already handled.
Run tl-update-asy --build on tug to make new support files ready.
+ (If there is a new asy, which there probably isn't at this point.)
6. Run tex \\end to check that dynamic mktexfmt works.
Ensure that web2c/texmf.cnf is updated for the current year (per above).
6a. Check that all formats build ok:
fmtutil-user --all >&/tmp/fua
-egrep -i 'ERROR|failed' /tmp/fua
+echo fua status = $?; egrep -i 'ERROR|failed' /tmp/fua
6b. For karl@tug.org: leave new ~karl/.texlive`date +%Y` for bnb.
Also, for ConTeXt:
- mtxrun --generate >&/tmp/mtxgen
- context --luatex --generate >&/tmp/cltxgen
+ mtxrun --generate >&/tmp/mtxgen || echo "mtxrun failed"
+ context --luatex --generate >&/tmp/cltxgen || echo "context luagen failed"
7. Check for Build-maintained updates to config files, new files, etc.
(might have to merge back if Master was mistakenly updated):
diff -ru0 --exclude=man --exclude=info \
- Build/source/inst/texmf-dist Master/texmf-dist
+ Build/source/inst/texmf-dist Master/texmf-dist >/tmp/cnfdif
7b. HiTeX: make install in hitexdir/tex and hitexdir/doc.
-7c. Asymptote: install new runtime files per tl-update-asy.
+7c. Asymptote: install new runtime files per tl-update-asy (if new asy).
8. Now, finally, try a first update of tlpretest:
env force_rebuild=true ~karl/bin/cron.pretest # ~15min
@@ -166,7 +171,7 @@ This will fail because the pretest dir is not yet set up, but
that's ok; the idea is to check the output and ensure all is basically ok.
The complaints about unknown "svn status output line"s are ok.
It's likely that .tlpsrc files will need to be adjusted for new binaries.
-When removing platforms, have to remove from /home/texlive/trunk.
+When removing platforms, also have to remove from /home/texlive/trunk.
8a. svn commit all the above.
diff --git a/Master/tlpkg/tlpsrc/cweb.tlpsrc b/Master/tlpkg/tlpsrc/cweb.tlpsrc
index 54cef6e063a..0360ae525ff 100644
--- a/Master/tlpkg/tlpsrc/cweb.tlpsrc
+++ b/Master/tlpkg/tlpsrc/cweb.tlpsrc
@@ -4,6 +4,7 @@ binpattern f bin/${ARCH}/ctangle
binpattern f bin/${ARCH}/cweave
#
binpattern f bin/${ARCH}/ctwill
+binpattern f bin/${ARCH}/ctwill-proofsort
binpattern f bin/${ARCH}/ctwill-refsort
binpattern f bin/${ARCH}/ctwill-twinx
binpattern f bin/${ARCH}/twill
diff --git a/Master/tlpkg/tlpsrc/ptex.tlpsrc b/Master/tlpkg/tlpsrc/ptex.tlpsrc
index 18984e0fd21..3118cb09622 100644
--- a/Master/tlpkg/tlpsrc/ptex.tlpsrc
+++ b/Master/tlpkg/tlpsrc/ptex.tlpsrc
@@ -20,6 +20,7 @@ binpattern f bin/${ARCH}/pdvitomp
binpattern f bin/${ARCH}/pdvitype
binpattern f bin/${ARCH}/pmpost
binpattern f bin/${ARCH}/ppltotf
+binpattern f bin/${ARCH}/ptekf
binpattern f bin/${ARCH}/ptex
binpattern f bin/${ARCH}/ptftopl
binpattern f bin/${ARCH}/r-pmpost